
;  GNU C 2.7.2 [AL 1.1, MM 40] RISC NEWS-OS compiled by CC

;  Cc1 defaults:
;  -mmemcpy

;  Cc1 arguments (-G value = 0, Cpu = 3000, ISA = 1):
;  -quiet -dumpbase -O2 -Wall -o

gcc2_compiled.:
__gnu_compiled_c:
; APP
	
	.code
	.align 1
	.global z80_run
z80_run:
	pushn %r3
	sub	%sp,0x1		; 	xsub %sp, %sp, 4
	;
	ld.w %r0, %r12			; z80
	ext	0x30		; 	xld.w %r1, [%r0+48]		; z80->read
	ld.w	%r1,[%r0]
	ext	0x24		; 	xld.w [%r0+36], %r13		; CYCLE
	ld.w	[%r0],%r13
	;
z80_run_L10:
	ext	0x23		; 	xld.ub %r10, [%r0+35]		; if(HALT) break
	ld.ub	%r10,[%r0]
	cmp	%r10,0x0	; 	xcmp %r10, 0
	jrne	z80_run_L30	; 	xjrne z80_run_L30
	ext	0x24		; 	xld.w %r10, [%r0+36]		; if(CYCLE <= 0) break
	ld.w	%r10,[%r0]
	cmp	%r10,0x0	; 	xcmp %r10, 0
	jrle	z80_run_L30	; 	xjrle z80_run_L30
	;
	ext	0x16		; 	xld.uh %r2, [%r0+22]		; PC
	ld.uh	%r2,[%r0]
	;
	ld.w %r12, %r0			; code = z80->read(z80, PC++)
	ld.uh %r13, %r2
	call.d %r1
	add %r2, 1			; *delay*
	ld.b	[%sp+0x0],%r10	; 	xld.b [%sp+0], %r10
	;
	ext	z80_op_table+0x0@h	; 	xld.w %r3, z80_op_table		; op = &z80_op_table[code]
	ext	z80_op_table+0x0@m
	ld.w	%r3,z80_op_table+0x0@l
	sll	%r10,0x3	; 	xsll %r10, 3
	add %r3, %r10
	;
	ext	0x4		; 	xld.ub %r10, [%r3+4]		; argc == 0 ?
	ld.ub	%r10,[%r3]
	cmp	%r10,0x0	; 	xcmp %r10, 0	
	jreq	z80_run_L20	; 	xjreq z80_run_L20
	;
	ld.w %r12, %r0			; arg1 = z80->read(z80, PC++)
	ld.uh %r13, %r2
	call.d %r1
	add %r2, 1			; *delay*
	ld.b	[%sp+0x1],%r10	; 	xld.b [%sp+1], %r10
	;
	ext	0x4		; 	xld.ub %r10, [%r3+4]		; argc == 1 ?
	ld.ub	%r10,[%r3]
	cmp	%r10,0x1	; 	xcmp %r10, 1	
	jreq	z80_run_L20	; 	xjreq z80_run_L20
	;
	ld.w %r12, %r0			; arg2 = z80->read(z80, PC++)
	ld.w %r13, %r2
	call.d %r1
	add %r2, 1			; *delay*
	ld.b	[%sp+0x2],%r10	; 	xld.b [%sp+2], %r10
	;
z80_run_L20:
	ext	0x16		; 	xld.h [%r0+22], %r2		; PC
	ld.h	[%r0],%r2
	;
	ld.w	%r10,[%r3]	; 	xld.w %r10, [%r3+0]		; op->proc(z80, code, arg1, arg2)
	ld.ub	%r13,[%sp+0x0]	; 	xld.ub %r13, [%sp+0]
	ld.ub	%r14,[%sp+0x1]	; 	xld.ub %r14, [%sp+1]
	ld.ub	%r15,[%sp+0x2]	; 	xld.ub %r15, [%sp+2]
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	ext	0x24		; 	xld.w %r10, [%r0+36]		; CYCLE -= op->cycle
	ld.w	%r10,[%r0]
	ext	0x5		; 	xld.ub %r11, [%r3+5]
	ld.ub	%r11,[%r3]
	sub %r10, %r11
	ext	0x24		; 	xld.w [%r0+36], %r10
	ld.w	[%r0],%r10
	;
	jp	z80_run_L10	; 	xjp z80_run_L10
z80_run_L30:
	;
	add	%sp,0x1		; 	xadd %sp, %sp, 4
	popn %r3
	ret

	
	.code
	.align 1
	.global z80op_CB
z80op_CB:
	pushn %r3
	sub	%sp,0x1		; 	xsub %sp, %sp, 4
	;
	ld.w %r0, %r12			; z80
	ext	0x30		; 	xld.w %r1, [%r0+48]		; z80->read
	ld.w	%r1,[%r0]
	;
	ext	0x16		; 	xld.uh %r2, [%r0+22]		; PC
	ld.uh	%r2,[%r0]
	;
	ld.w %r12, %r0			; code = z80->read(z80, PC++)
	ld.uh %r13, %r2
	call.d %r1
	add %r2, 1			; *delay*
	ld.b	[%sp+0x0],%r10	; 	xld.b [%sp+0], %r10
	;
	ext	z80_op_table_CB+0x0@h	; 	xld.w %r3, z80_op_table_CB	; op = &z80_op_table_CB[code]
	ext	z80_op_table_CB+0x0@m
	ld.w	%r3,z80_op_table_CB+0x0@l
	sll	%r10,0x3	; 	xsll %r10, 3
	add %r3, %r10
	;
	ext	0x4		; 	xld.ub %r10, [%r3+4]		; argc == 0 ?
	ld.ub	%r10,[%r3]
	cmp	%r10,0x0	; 	xcmp %r10, 0	
	jreq	z80op_CB_L10	; 	xjreq z80op_CB_L10
	;
	ld.w %r12, %r0			; arg1 = z80->read(z80, PC++)
	ld.uh %r13, %r2
	call.d %r1
	add %r2, 1			; *delay*
	ld.b	[%sp+0x1],%r10	; 	xld.b [%sp+1], %r10
	;
	ext	0x4		; 	xld.ub %r10, [%r3+4]		; argc == 1 ?
	ld.ub	%r10,[%r3]
	cmp	%r10,0x1	; 	xcmp %r10, 1	
	jreq	z80op_CB_L10	; 	xjreq z80op_CB_L10
	;
	ld.w %r12, %r0			; arg2 = z80->read(z80, PC++)
	ld.w %r13, %r2
	call.d %r1
	add %r2, 1			; *delay*
	ld.b	[%sp+0x2],%r10	; 	xld.b [%sp+2], %r10
	;
z80op_CB_L10:
	ext	0x16		; 	xld.h [%r0+22], %r2		; PC
	ld.h	[%r0],%r2
	;
	ld.w	%r10,[%r3]	; 	xld.w %r10, [%r3+0]		; op->proc(z80, code, arg1, arg2)
	ld.ub	%r13,[%sp+0x0]	; 	xld.ub %r13, [%sp+0]
	ld.ub	%r14,[%sp+0x1]	; 	xld.ub %r14, [%sp+1]
	ld.ub	%r15,[%sp+0x2]	; 	xld.ub %r15, [%sp+2]
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	ext	0x24		; 	xld.w %r10, [%r0+36]		; CYCLE -= op->cycle
	ld.w	%r10,[%r0]
	ext	0x5		; 	xld.ub %r11, [%r3+5]
	ld.ub	%r11,[%r3]
	sub %r10, %r11
	ext	0x24		; 	xld.w [%r0+36], %r10
	ld.w	[%r0],%r10
	;
	add	%sp,0x1		; 	xadd %sp, %sp, 4
	popn %r3
	ret

	
	.code
	.align 1
	.global z80op_ED
z80op_ED:
	pushn %r3
	sub	%sp,0x1		; 	xsub %sp, %sp, 4
	;
	ld.w %r0, %r12			; z80
	ext	0x30		; 	xld.w %r1, [%r0+48]		; z80->read
	ld.w	%r1,[%r0]
	;
	ext	0x16		; 	xld.uh %r2, [%r0+22]		; PC
	ld.uh	%r2,[%r0]
	;
	ld.w %r12, %r0			; code = z80->read(z80, PC++)
	ld.uh %r13, %r2
	call.d %r1
	add %r2, 1			; *delay*
	ld.b	[%sp+0x0],%r10	; 	xld.b [%sp+0], %r10
	;
	ext	z80_op_table_ED+0x0@h	; 	xld.w %r3, z80_op_table_ED	; op = &z80_op_table_ED[code]
	ext	z80_op_table_ED+0x0@m
	ld.w	%r3,z80_op_table_ED+0x0@l
	sll	%r10,0x3	; 	xsll %r10, 3
	add %r3, %r10
	;
	ext	0x4		; 	xld.ub %r10, [%r3+4]		; argc == 0 ?
	ld.ub	%r10,[%r3]
	cmp	%r10,0x0	; 	xcmp %r10, 0	
	jreq	z80op_ED_L10	; 	xjreq z80op_ED_L10
	;
	ld.w %r12, %r0			; arg1 = z80->read(z80, PC++)
	ld.uh %r13, %r2
	call.d %r1
	add %r2, 1			; *delay*
	ld.b	[%sp+0x1],%r10	; 	xld.b [%sp+1], %r10
	;
	ld.w %r12, %r0			; arg2 = z80->read(z80, PC++)
	ld.w %r13, %r2
	call.d %r1
	add %r2, 1			; *delay*
	ld.b	[%sp+0x2],%r10	; 	xld.b [%sp+2], %r10
	;
z80op_ED_L10:
	ext	0x16		; 	xld.h [%r0+22], %r2		; PC
	ld.h	[%r0],%r2
	;
	ld.w	%r10,[%r3]	; 	xld.w %r10, [%r3+0]		; op->proc(z80, code, arg1, arg2)
	ld.ub	%r13,[%sp+0x0]	; 	xld.ub %r13, [%sp+0]
	ld.ub	%r14,[%sp+0x1]	; 	xld.ub %r14, [%sp+1]
	ld.ub	%r15,[%sp+0x2]	; 	xld.ub %r15, [%sp+2]
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	ext	0x24		; 	xld.w %r10, [%r0+36]		; CYCLE -= op->cycle
	ld.w	%r10,[%r0]
	ext	0x5		; 	xld.ub %r11, [%r3+5]
	ld.ub	%r11,[%r3]
	sub %r10, %r11
	ext	0x24		; 	xld.w [%r0+36], %r10
	ld.w	[%r0],%r10
	;
	add	%sp,0x1		; 	xadd %sp, %sp, 4
	popn %r3
	ret

	
	.code
	.align 1
	.global z80op_DD
z80op_DD:
	pushn %r3
	sub	%sp,0x1		; 	xsub %sp, %sp, 4
	;
	ld.w %r0, %r12			; z80
	ext	0x30		; 	xld.w %r1, [%r0+48]		; z80->read
	ld.w	%r1,[%r0]
	;
	ext	0x16		; 	xld.uh %r2, [%r0+22]		; PC
	ld.uh	%r2,[%r0]
	;
	ld.w %r12, %r0			; code = z80->read(z80, PC++)
	ld.uh %r13, %r2
	call.d %r1
	add %r2, 1			; *delay*
	ld.b	[%sp+0x0],%r10	; 	xld.b [%sp+0], %r10
	;
	ext	z80_op_table_DD+0x0@h	; 	xld.w %r3, z80_op_table_DD	; op = &z80_op_table_DD[code]
	ext	z80_op_table_DD+0x0@m
	ld.w	%r3,z80_op_table_DD+0x0@l
	sll	%r10,0x3	; 	xsll %r10, 3
	add %r3, %r10
	;
	ext	0x4		; 	xld.ub %r10, [%r3+4]		; argc == 0 ?
	ld.ub	%r10,[%r3]
	cmp	%r10,0x0	; 	xcmp %r10, 0	
	jreq	z80op_DD_L10	; 	xjreq z80op_DD_L10
	;
	ld.w %r12, %r0			; arg1 = z80->read(z80, PC++)
	ld.uh %r13, %r2
	call.d %r1
	add %r2, 1			; *delay*
	ld.b	[%sp+0x1],%r10	; 	xld.b [%sp+1], %r10
	;
	ext	0x4		; 	xld.ub %r10, [%r3+4]		; argc == 1 ?
	ld.ub	%r10,[%r3]
	cmp	%r10,0x1	; 	xcmp %r10, 1	
	jreq	z80op_DD_L10	; 	xjreq z80op_DD_L10
	;
	ld.w %r12, %r0			; arg2 = z80->read(z80, PC++)
	ld.w %r13, %r2
	call.d %r1
	add %r2, 1			; *delay*
	ld.b	[%sp+0x2],%r10	; 	xld.b [%sp+2], %r10
	;
z80op_DD_L10:
	ext	0x16		; 	xld.h [%r0+22], %r2		; PC
	ld.h	[%r0],%r2
	;
	ld.w	%r10,[%r3]	; 	xld.w %r10, [%r3+0]		; op->proc(z80, code, arg1, arg2)
	ld.ub	%r13,[%sp+0x0]	; 	xld.ub %r13, [%sp+0]
	ld.ub	%r14,[%sp+0x1]	; 	xld.ub %r14, [%sp+1]
	ld.ub	%r15,[%sp+0x2]	; 	xld.ub %r15, [%sp+2]
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	ext	0x24		; 	xld.w %r10, [%r0+36]		; CYCLE -= op->cycle
	ld.w	%r10,[%r0]
	ext	0x5		; 	xld.ub %r11, [%r3+5]
	ld.ub	%r11,[%r3]
	sub %r10, %r11
	ext	0x24		; 	xld.w [%r0+36], %r10
	ld.w	[%r0],%r10
	;
	add	%sp,0x1		; 	xadd %sp, %sp, 4
	popn %r3
	ret

	
	.code
	.align 1
	.global z80op_FD
z80op_FD:
	pushn %r3
	sub	%sp,0x1		; 	xsub %sp, %sp, 4
	;
	ld.w %r0, %r12			; z80
	ext	0x30		; 	xld.w %r1, [%r0+48]		; z80->read
	ld.w	%r1,[%r0]
	;
	ext	0x16		; 	xld.uh %r2, [%r0+22]		; PC
	ld.uh	%r2,[%r0]
	;
	ld.w %r12, %r0			; code = z80->read(z80, PC++)
	ld.uh %r13, %r2
	call.d %r1
	add %r2, 1			; *delay*
	ld.b	[%sp+0x0],%r10	; 	xld.b [%sp+0], %r10
	;
	ext	z80_op_table_FD+0x0@h	; 	xld.w %r3, z80_op_table_FD	; op = &z80_op_table_FD[code]
	ext	z80_op_table_FD+0x0@m
	ld.w	%r3,z80_op_table_FD+0x0@l
	sll	%r10,0x3	; 	xsll %r10, 3
	add %r3, %r10
	;
	ext	0x4		; 	xld.ub %r10, [%r3+4]		; argc == 0 ?
	ld.ub	%r10,[%r3]
	cmp	%r10,0x0	; 	xcmp %r10, 0	
	jreq	z80op_FD_L10	; 	xjreq z80op_FD_L10
	;
	ld.w %r12, %r0			; arg1 = z80->read(z80, PC++)
	ld.uh %r13, %r2
	call.d %r1
	add %r2, 1			; *delay*
	ld.b	[%sp+0x1],%r10	; 	xld.b [%sp+1], %r10
	;
	ext	0x4		; 	xld.ub %r10, [%r3+4]		; argc == 1 ?
	ld.ub	%r10,[%r3]
	cmp	%r10,0x1	; 	xcmp %r10, 1	
	jreq	z80op_FD_L10	; 	xjreq z80op_FD_L10
	;
	ld.w %r12, %r0			; arg2 = z80->read(z80, PC++)
	ld.w %r13, %r2
	call.d %r1
	add %r2, 1			; *delay*
	ld.b	[%sp+0x2],%r10	; 	xld.b [%sp+2], %r10
	;
z80op_FD_L10:
	ext	0x16		; 	xld.h [%r0+22], %r2		; PC
	ld.h	[%r0],%r2
	;
	ld.w	%r10,[%r3]	; 	xld.w %r10, [%r3+0]		; op->proc(z80, code, arg1, arg2)
	ld.ub	%r13,[%sp+0x0]	; 	xld.ub %r13, [%sp+0]
	ld.ub	%r14,[%sp+0x1]	; 	xld.ub %r14, [%sp+1]
	ld.ub	%r15,[%sp+0x2]	; 	xld.ub %r15, [%sp+2]
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	ext	0x24		; 	xld.w %r10, [%r0+36]		; CYCLE -= op->cycle
	ld.w	%r10,[%r0]
	ext	0x5		; 	xld.ub %r11, [%r3+5]
	ld.ub	%r11,[%r3]
	sub %r10, %r11
	ext	0x24		; 	xld.w [%r0+36], %r10
	ld.w	[%r0],%r10
	;
	add	%sp,0x1		; 	xadd %sp, %sp, 4
	popn %r3
	ret

	
	.code
	.align 1
	.global z80op_DDCB
z80op_DDCB:
	pushn %r3
	sub	%sp,0x1		; 	xsub %sp, %sp, 4
	;
	ld.w %r0, %r12			; z80
	ext	0x30		; 	xld.w %r1, [%r0+48]		; z80->read
	ld.w	%r1,[%r0]
	;
	ext	0x16		; 	xld.uh %r2, [%r0+22]		; PC
	ld.uh	%r2,[%r0]
	;
	ld.w %r12, %r0			; arg1 = z80->read(z80, PC++)
	ld.uh %r13, %r2
	call.d %r1
	add %r2, 1			; *delay*
	ld.b	[%sp+0x1],%r10	; 	xld.b [%sp+1], %r10
	;
	ld.w %r12, %r0			; code = z80->read(z80, PC++)
	ld.uh %r13, %r2
	call.d %r1
	add %r2, 1			; *delay*
	ld.b	[%sp+0x0],%r10	; 	xld.b [%sp+0], %r10
	;
	ext	z80_op_table_DDCB+0x0@h	; 	xld.w %r3, z80_op_table_DDCB	; op = &z80_op_table_DDCB[code]
	ext	z80_op_table_DDCB+0x0@m
	ld.w	%r3,z80_op_table_DDCB+0x0@l
	sll	%r10,0x3	; 	xsll %r10, 3
	add %r3, %r10
	;
	ext	0x16		; 	xld.h [%r0+22], %r2		; PC
	ld.h	[%r0],%r2
	;
	ld.w	%r10,[%r3]	; 	xld.w %r10, [%r3+0]		; op->proc(z80, code, arg1, /*arg2*/)
	ld.ub	%r13,[%sp+0x0]	; 	xld.ub %r13, [%sp+0]
	ld.ub	%r14,[%sp+0x1]	; 	xld.ub %r14, [%sp+1]
	;/*xld.ub %r15, [%sp+2]*/
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	ext	0x24		; 	xld.w %r10, [%r0+36]		; CYCLE -= op->cycle
	ld.w	%r10,[%r0]
	ext	0x5		; 	xld.ub %r11, [%r3+5]
	ld.ub	%r11,[%r3]
	sub %r10, %r11
	ext	0x24		; 	xld.w [%r0+36], %r10
	ld.w	[%r0],%r10
	;
	add	%sp,0x1		; 	xadd %sp, %sp, 4
	popn %r3
	ret

	
	.code
	.align 1
	.global z80op_FDCB
z80op_FDCB:
	pushn %r3
	sub	%sp,0x1		; 	xsub %sp, %sp, 4
	;
	ld.w %r0, %r12			; z80
	ext	0x30		; 	xld.w %r1, [%r0+48]		; z80->read
	ld.w	%r1,[%r0]
	;
	ext	0x16		; 	xld.uh %r2, [%r0+22]		; PC
	ld.uh	%r2,[%r0]
	;
	ld.w %r12, %r0			; arg1 = z80->read(z80, PC++)
	ld.uh %r13, %r2
	call.d %r1
	add %r2, 1			; *delay*
	ld.b	[%sp+0x1],%r10	; 	xld.b [%sp+1], %r10
	;
	ld.w %r12, %r0			; code = z80->read(z80, PC++)
	ld.uh %r13, %r2
	call.d %r1
	add %r2, 1			; *delay*
	ld.b	[%sp+0x0],%r10	; 	xld.b [%sp+0], %r10
	;
	ext	z80_op_table_FDCB+0x0@h	; 	xld.w %r3, z80_op_table_FDCB	; op = &z80_op_table_FDCB[code]
	ext	z80_op_table_FDCB+0x0@m
	ld.w	%r3,z80_op_table_FDCB+0x0@l
	sll	%r10,0x3	; 	xsll %r10, 3
	add %r3, %r10
	;
	ext	0x16		; 	xld.h [%r0+22], %r2		; PC
	ld.h	[%r0],%r2
	;
	ld.w	%r10,[%r3]	; 	xld.w %r10, [%r3+0]		; op->proc(z80, code, arg1, /*arg2*/)
	ld.ub	%r13,[%sp+0x0]	; 	xld.ub %r13, [%sp+0]
	ld.ub	%r14,[%sp+0x1]	; 	xld.ub %r14, [%sp+1]
	;/*xld.ub %r15, [%sp+2]*/
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	ext	0x24		; 	xld.w %r10, [%r0+36]		; CYCLE -= op->cycle
	ld.w	%r10,[%r0]
	ext	0x5		; 	xld.ub %r11, [%r3+5]
	ld.ub	%r11,[%r3]
	sub %r10, %r11
	ext	0x24		; 	xld.w [%r0+36], %r10
	ld.w	[%r0],%r10
	;
	add	%sp,0x1		; 	xadd %sp, %sp, 4
	popn %r3
	ret

; NO_APP
	.code
	.align	1
	.global	z80_PARITY
z80_PARITY:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.w	%r11,0x4	; 	xld.w	%r11,0x00000004		; 4
	jp	__LX32		; 	xjp	__L32
__LX29:				; __L29:
	ld.w	%r10,%r12
	and	%r10,0x1	; 	xand	%r10,%r10,0x00000001
	jreq	__LX30		; 	xjreq	__L30
	xor	%r11,0x4	; 	xxor	%r11,%r11,0x00000004
__LX30:				; __L30:
	ld.ub	%r10,%r12
	ld.w	%r12,%r10
	srl	%r12,0x1	; 	xsrl	%r12,1
__LX32:				; __L32:
	ld.ub	%r10,%r12
	cmp	%r10,0x0
	jrne	__LX29		; 	xjrne	__L29
	ld.ub	%r10,%r11
	ret
	.align	1
	.global	z80_ADD8
z80_ADD8:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.w	%r4,%r12
	ext	0x1		; 	xld.ub	%r10,[%r4+1]
	ld.ub	%r10,[%r4]
	ld.ub	%r14,%r10
	ld.ub	%r11,%r13
	ld.w	%r15,%r14
	add	%r15,%r11
	ld.w	%r5,%r15
	ext	0x2		; 	xand	%r5,%r5,0x000000a8
	and	%r5,0x28
	ld.w	%r11,%r10
	and	%r11,0xf	; 	xand	%r11,%r11,0x0000000f
	ld.w	%r12,%r13
	and	%r12,0xf	; 	xand	%r12,%r12,0x0000000f
	add	%r11,%r12
	and	%r11,0x10	; 	xand	%r11,%r11,0x00000010
	xor	%r10,%r13
	ld.ub	%r10,%r10
	not	%r10,%r10
	xor	%r14,%r15
	and	%r10,%r14
	ext	0x2		; 	xand	%r10,%r10,0x00000080
	and	%r10,0x0
	ld.w	%r12,%r10
	sra	%r12,0x5	; 	xsra	%r12,5
	ld.w	%r13,%r15
	srl	%r13,0x8	; 	xsrl	%r13,8
	ld.ub	%r10,%r15
	cmp	%r10,0x0
	jrne	__LX34		; 	xjrne	__L34
	ld.w	%r10,%r11
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
	or	%r5,%r10
	ld.w	%r10,%r5
	jp	__LX36		; 	xjp	__L36
__LX34:				; __L34:
	ld.w	%r10,%r5
	or	%r10,%r11
__LX36:				; __L36:
	or	%r10,%r12
	or	%r10,%r13
	ld.b	[%r4],%r10	; 	xld.b	[%r4],%r10
	ext	0x1		; 	xld.b	[%r4+1],%r15
	ld.b	[%r4],%r15
	ret
	.align	1
	.global	z80_ADC8
z80_ADC8:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.w	%r5,%r12
	ld.ub	%r15,[%r5]	; 	xld.ub	%r15,[%r5]
	and	%r15,0x1	; 	xand	%r15,%r15,0x00000001
	ext	0x1		; 	xld.ub	%r11,[%r5+1]
	ld.ub	%r11,[%r5]
	ld.ub	%r14,%r11
	ld.ub	%r10,%r13
	ld.w	%r7,%r14
	add	%r7,%r10
	ld.w	%r10,%r7
	ld.w	%r4,%r10
	add	%r4,%r15
	ld.w	%r6,%r4
	ext	0x2		; 	xand	%r6,%r6,0x000000a8
	and	%r6,0x28
	ld.w	%r10,%r11
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.w	%r12,%r13
	and	%r12,0xf	; 	xand	%r12,%r12,0x0000000f
	add	%r10,%r12
	add	%r10,%r15
	ld.w	%r15,%r10
	and	%r15,0x10	; 	xand	%r15,%r15,0x00000010
	xor	%r11,%r13
	ld.ub	%r11,%r11
	not	%r11,%r11
	xor	%r14,%r4
	and	%r11,%r14
	ext	0x2		; 	xand	%r11,%r11,0x00000080
	and	%r11,0x0
	sra	%r11,0x5	; 	xsra	%r11,5
	ld.w	%r10,%r4
	sra	%r10,0x8	; 	xsra	%r10,8
	ld.w	%r12,%r10
	and	%r12,0x1	; 	xand	%r12,%r12,0x00000001
	ld.ub	%r10,%r4
	cmp	%r10,0x0
	jrne	__LX38		; 	xjrne	__L38
	ld.w	%r10,%r15
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
	or	%r6,%r10
	ld.w	%r10,%r6
	jp	__LX40		; 	xjp	__L40
__LX38:				; __L38:
	ld.w	%r10,%r6
	or	%r10,%r15
__LX40:				; __L40:
	or	%r10,%r11
	or	%r10,%r12
	ld.b	[%r5],%r10	; 	xld.b	[%r5],%r10
	ext	0x1		; 	xld.b	[%r5+1],%r4
	ld.b	[%r5],%r4
	ret
	.align	1
	.global	z80_SUB8
z80_SUB8:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.w	%r4,%r12
	ext	0x1		; 	xld.ub	%r11,[%r4+1]
	ld.ub	%r11,[%r4]
	ld.ub	%r14,%r11
	ld.ub	%r10,%r13
	ld.w	%r15,%r14
	sub	%r15,%r10
	ld.w	%r6,%r15
	ext	0x2		; 	xand	%r6,%r6,0x000000a8
	and	%r6,0x28
	ld.w	%r10,%r11
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.w	%r12,%r13
	and	%r12,0xf	; 	xand	%r12,%r12,0x0000000f
	sub	%r10,%r12
	ld.w	%r5,%r10
	and	%r5,0x10	; 	xand	%r5,%r5,0x00000010
	xor	%r11,%r13
	ld.ub	%r11,%r11
	xor	%r14,%r15
	and	%r11,%r14
	ext	0x2		; 	xand	%r11,%r11,0x00000080
	and	%r11,0x0
	sra	%r11,0x5	; 	xsra	%r11,5
	ld.w	%r10,%r15
	sra	%r10,0x8	; 	xsra	%r10,8
	ld.w	%r12,%r10
	and	%r12,0x1	; 	xand	%r12,%r12,0x00000001
	ld.ub	%r10,%r15
	cmp	%r10,0x0
	jrne	__LX42		; 	xjrne	__L42
	ld.w	%r10,%r5
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
	or	%r6,%r10
	ld.w	%r10,%r6
	jp	__LX44		; 	xjp	__L44
__LX42:				; __L42:
	ld.w	%r10,%r6
	or	%r10,%r5
__LX44:				; __L44:
	or	%r10,%r11
	ld.w	%r11,%r12
	or	%r11,0x2	; 	xoor	%r11,%r11,0x00000002
	or	%r10,%r11
	ld.b	[%r4],%r10	; 	xld.b	[%r4],%r10
	ext	0x1		; 	xld.b	[%r4+1],%r15
	ld.b	[%r4],%r15
	ret
	.align	1
	.global	z80_SBC8
z80_SBC8:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.w	%r5,%r12
	ld.ub	%r15,[%r5]	; 	xld.ub	%r15,[%r5]
	and	%r15,0x1	; 	xand	%r15,%r15,0x00000001
	ext	0x1		; 	xld.ub	%r11,[%r5+1]
	ld.ub	%r11,[%r5]
	ld.ub	%r14,%r11
	ld.ub	%r10,%r13
	ld.w	%r7,%r14
	sub	%r7,%r10
	ld.w	%r10,%r7
	ld.w	%r4,%r10
	sub	%r4,%r15
	ld.w	%r6,%r4
	ext	0x2		; 	xand	%r6,%r6,0x000000a8
	and	%r6,0x28
	ld.w	%r10,%r11
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.w	%r12,%r13
	and	%r12,0xf	; 	xand	%r12,%r12,0x0000000f
	sub	%r10,%r12
	sub	%r10,%r15
	ld.w	%r15,%r10
	and	%r15,0x10	; 	xand	%r15,%r15,0x00000010
	xor	%r11,%r13
	ld.ub	%r11,%r11
	xor	%r14,%r4
	and	%r11,%r14
	ext	0x2		; 	xand	%r11,%r11,0x00000080
	and	%r11,0x0
	sra	%r11,0x5	; 	xsra	%r11,5
	ld.w	%r10,%r4
	sra	%r10,0x8	; 	xsra	%r10,8
	ld.w	%r12,%r10
	and	%r12,0x1	; 	xand	%r12,%r12,0x00000001
	ld.ub	%r10,%r4
	cmp	%r10,0x0
	jrne	__LX46		; 	xjrne	__L46
	ld.w	%r10,%r15
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
	or	%r6,%r10
	ld.w	%r10,%r6
	jp	__LX48		; 	xjp	__L48
__LX46:				; __L46:
	ld.w	%r10,%r6
	or	%r10,%r15
__LX48:				; __L48:
	or	%r10,%r11
	ld.w	%r11,%r12
	or	%r11,0x2	; 	xoor	%r11,%r11,0x00000002
	or	%r10,%r11
	ld.b	[%r5],%r10	; 	xld.b	[%r5],%r10
	ext	0x1		; 	xld.b	[%r5+1],%r4
	ld.b	[%r5],%r4
	ret
	.align	1
	.global	z80_AND
z80_AND:
;	.frame	%sp,12,$31		# vars= 0, regs= 3/0, args= 0, extra= 0
;	.mask	0x80030000,-4
;	.fmask	0x00000000,0
	pushn	%r1
	ld.w	%r0,%r12
	ext	0x1		; 	xld.ub	%r12,[%r0+1]
	ld.ub	%r12,[%r0]
	and	%r12,%r13
	ext	0x1		; 	xld.b	[%r0+1],%r12
	ld.b	[%r0],%r12
	ld.w	%r1,%r12
	ext	0x2		; 	xand	%r1,%r1,0x000000a8
	and	%r1,0x28
	ext	z80_PARITY@rm	; 	xcall	z80_PARITY
	call	z80_PARITY@rl
	ld.ub	%r11,%r10
	ext	0x1		; 	xld.ub	%r10,[%r0+1]
	ld.ub	%r10,[%r0]
	cmp	%r10,0x0
	jrne	__LX50		; 	xjrne	__L50
	ld.w	%r10,%r11
	ext	0x1		; 	xoor	%r10,%r10,0x00000050
	or	%r10,0x10
	jp	__LX52		; 	xjp	__L52
__LX50:				; __L50:
	ld.w	%r10,%r11
	or	%r10,0x10	; 	xoor	%r10,%r10,0x00000010
__LX52:				; __L52:
	or	%r1,%r10
	ld.w	%r10,%r1
	ld.b	[%r0],%r10	; 	xld.b	[%r0],%r10
	popn	%r1
	ret
	.align	1
	.global	z80_OR
z80_OR:
;	.frame	%sp,12,$31		# vars= 0, regs= 3/0, args= 0, extra= 0
;	.mask	0x80030000,-4
;	.fmask	0x00000000,0
	pushn	%r1
	ld.w	%r0,%r12
	ext	0x1		; 	xld.ub	%r12,[%r0+1]
	ld.ub	%r12,[%r0]
	or	%r12,%r13
	ext	0x1		; 	xld.b	[%r0+1],%r12
	ld.b	[%r0],%r12
	ld.w	%r1,%r12
	ext	0x2		; 	xand	%r1,%r1,0x000000a8
	and	%r1,0x28
	ld.ub	%r12,%r12
	ext	z80_PARITY@rm	; 	xcall	z80_PARITY
	call	z80_PARITY@rl
	ld.ub	%r11,%r10
	ext	0x1		; 	xld.ub	%r10,[%r0+1]
	ld.ub	%r10,[%r0]
	cmp	%r10,0x0
	jrne	__LX54		; 	xjrne	__L54
	ld.w	%r10,%r11
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
	or	%r1,%r10
	ld.w	%r10,%r1
	jp	__LX55		; 	xjp	__L55
__LX54:				; __L54:
	ld.w	%r10,%r1
	or	%r10,%r11
__LX55:				; __L55:
	ld.b	[%r0],%r10	; 	xld.b	[%r0],%r10
	popn	%r1
	ret
	.align	1
	.global	z80_XOR
z80_XOR:
;	.frame	%sp,12,$31		# vars= 0, regs= 3/0, args= 0, extra= 0
;	.mask	0x80030000,-4
;	.fmask	0x00000000,0
	pushn	%r1
	ld.w	%r0,%r12
	ext	0x1		; 	xld.ub	%r12,[%r0+1]
	ld.ub	%r12,[%r0]
	xor	%r12,%r13
	ext	0x1		; 	xld.b	[%r0+1],%r12
	ld.b	[%r0],%r12
	ld.w	%r1,%r12
	ext	0x2		; 	xand	%r1,%r1,0x000000a8
	and	%r1,0x28
	ld.ub	%r12,%r12
	ext	z80_PARITY@rm	; 	xcall	z80_PARITY
	call	z80_PARITY@rl
	ld.ub	%r11,%r10
	ext	0x1		; 	xld.ub	%r10,[%r0+1]
	ld.ub	%r10,[%r0]
	cmp	%r10,0x0
	jrne	__LX57		; 	xjrne	__L57
	ld.w	%r10,%r11
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
	or	%r1,%r10
	ld.w	%r10,%r1
	jp	__LX58		; 	xjp	__L58
__LX57:				; __L57:
	ld.w	%r10,%r1
	or	%r10,%r11
__LX58:				; __L58:
	ld.b	[%r0],%r10	; 	xld.b	[%r0],%r10
	popn	%r1
	ret
	.align	1
	.global	z80_CP
z80_CP:
;	.frame	%sp,8,$31		# vars= 0, regs= 2/0, args= 0, extra= 0
;	.mask	0x80010000,-4
;	.fmask	0x00000000,0
	pushn	%r0
	ld.w	%r6,%r12
	ext	0x1		; 	xld.ub	%r11,[%r6+1]
	ld.ub	%r11,[%r6]
	ld.ub	%r15,%r11
	ld.ub	%r14,%r13
	ld.w	%r0,%r15
	sub	%r0,%r14
	ld.w	%r14,%r0
	ext	0x2		; 	xld.w	%r4,0x00000080		; 128
	ld.w	%r4,0x0
	ld.w	%r12,%r14
	and	%r12,%r4
	ld.w	%r10,%r13
	ext	0x0		; 	xand	%r10,%r10,0x00000028
	and	%r10,0x28
	ld.w	%r7,%r12
	or	%r7,%r10
	ld.w	%r10,%r11
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.w	%r12,%r13
	and	%r12,0xf	; 	xand	%r12,%r12,0x0000000f
	sub	%r10,%r12
	ld.w	%r5,%r10
	and	%r5,0x10	; 	xand	%r5,%r5,0x00000010
	xor	%r11,%r13
	ld.ub	%r11,%r11
	xor	%r15,%r14
	and	%r11,%r15
	and	%r11,%r4
	sra	%r11,0x5	; 	xsra	%r11,5
	ld.w	%r10,%r14
	sra	%r10,0x8	; 	xsra	%r10,8
	ld.w	%r12,%r10
	and	%r12,0x1	; 	xand	%r12,%r12,0x00000001
	ld.ub	%r14,%r14
	cmp	%r14,0x0
	jrne	__LX60		; 	xjrne	__L60
	ld.w	%r10,%r5
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
	or	%r7,%r10
	ld.w	%r10,%r7
	jp	__LX62		; 	xjp	__L62
__LX60:				; __L60:
	ld.w	%r10,%r7
	or	%r10,%r5
__LX62:				; __L62:
	or	%r10,%r11
	ld.w	%r11,%r12
	or	%r11,0x2	; 	xoor	%r11,%r11,0x00000002
	or	%r10,%r11
	ld.b	[%r6],%r10	; 	xld.b	[%r6],%r10
	popn	%r0
	ret
	.align	1
	.global	z80_INC8
z80_INC8:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	ld.w	%r15,%r13
	ld.w	%r10,%r13
	ext	0x2		; 	xand	%r10,%r10,0x000000a8
	and	%r10,0x28
	ld.ub	%r14,%r15
	cmp	%r14,0x0
	jrne	__LX64		; 	xjrne	__L64
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
__LX64:				; __L64:
	ld.w	%r11,%r10
	ld.w	%r10,%r13
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	jrne	__LX65		; 	xjrne	__L65
	or	%r11,0x10	; 	xoor	%r11,%r11,0x00000010
__LX65:				; __L65:
	ld.ub	%r10,[%r12]	; 	xld.ub	%r10,[%r12]
	and	%r10,0x1	; 	xand	%r10,%r10,0x00000001
	ext	0x2		; 	xcmp	%r14,128
	cmp	%r14,0x0
	jrne	__LX66		; 	xjrne	__L66
	or	%r10,0x4	; 	xoor	%r10,%r10,0x00000004
__LX66:				; __L66:
	or	%r11,%r10
	ld.w	%r10,%r11
	ld.b	[%r12],%r10	; 	xld.b	[%r12],%r10
	ld.ub	%r10,%r15
	ret
	.align	1
	.global	z80_DEC8
z80_DEC8:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	ld.w	%r15,%r13
	ld.w	%r10,%r13
	ext	0x2		; 	xand	%r10,%r10,0x000000a8
	and	%r10,0x28
	ld.ub	%r14,%r15
	cmp	%r14,0x0
	jrne	__LX69		; 	xjrne	__L69
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
__LX69:				; __L69:
	ld.w	%r11,%r10
	ld.w	%r10,%r13
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	cmp	%r10,0xf	; 	xcmp	%r10,15
	jrne	__LX70		; 	xjrne	__L70
	or	%r11,0x10	; 	xoor	%r11,%r11,0x00000010
__LX70:				; __L70:
	ld.ub	%r10,[%r12]	; 	xld.ub	%r10,[%r12]
	and	%r10,0x1	; 	xand	%r10,%r10,0x00000001
	ext	0x1		; 	xcmp	%r14,127
	cmp	%r14,0x3f
	jrne	__LX71		; 	xjrne	__L71
	or	%r10,0x6	; 	xoor	%r10,%r10,0x00000006
	jp	__LX73		; 	xjp	__L73
__LX71:				; __L71:
	or	%r10,0x2	; 	xoor	%r10,%r10,0x00000002
__LX73:				; __L73:
	or	%r11,%r10
	ld.w	%r10,%r11
	ld.b	[%r12],%r10	; 	xld.b	[%r12],%r10
	ld.ub	%r10,%r15
	ret
	.align	1
	.global	z80_ADD16
z80_ADD16:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.uh	%r10,%r13
	ld.uh	%r11,%r14
	add	%r10,%r11
	ld.ub	%r4,[%r12]	; 	xld.ub	%r4,[%r12]
	ext	0x3		; 	xand	%r4,%r4,0x000000c4
	and	%r4,0x4
	ld.w	%r11,%r10
	sra	%r11,0x8	; 	xsra	%r11,8
	ext	0x0		; 	xand	%r11,%r11,0x00000028
	and	%r11,0x28
	or	%r4,%r11
	ext	0x3f		; 	xld.w	%r15,0x00000fff		; 4095
	ld.w	%r15,0x3f
	ld.w	%r11,%r15
	and	%r11,%r13
	and	%r15,%r14
	add	%r11,%r15
	sra	%r11,0x8	; 	xsra	%r11,8
	and	%r11,0x10	; 	xand	%r11,%r11,0x00000010
	or	%r4,%r11
	ld.w	%r11,%r10
	srl	%r11,0x8	; 	xsrl	%r11,16
	srl	%r11,0x8
	or	%r4,%r11
	ld.b	[%r12],%r4	; 	xld.b	[%r12],%r4
	ld.uh	%r10,%r10
	ret
	.align	1
	.global	z80_ADC16
z80_ADC16:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.w	%r5,%r12
	ld.ub	%r15,[%r5]	; 	xld.ub	%r15,[%r5]
	and	%r15,0x1	; 	xand	%r15,%r15,0x00000001
	ld.uh	%r12,%r13
	ld.uh	%r10,%r14
	ld.w	%r7,%r12
	add	%r7,%r10
	ld.w	%r10,%r7
	ld.w	%r4,%r10
	add	%r4,%r15
	ld.w	%r10,%r4
	sra	%r10,0x8	; 	xsra	%r10,8
	ld.w	%r6,%r10
	ext	0x2		; 	xand	%r6,%r6,0x000000a8
	and	%r6,0x28
	ext	0x3f		; 	xld.w	%r11,0x00000fff		; 4095
	ld.w	%r11,0x3f
	ld.w	%r10,%r11
	and	%r10,%r13
	and	%r11,%r14
	add	%r10,%r11
	add	%r10,%r15
	sra	%r10,0x8	; 	xsra	%r10,8
	ld.w	%r15,%r10
	and	%r15,0x10	; 	xand	%r15,%r15,0x00000010
	xor	%r13,%r14
	ld.uh	%r13,%r13
	not	%r13,%r13
	xor	%r12,%r4
	and	%r13,%r12
	ext	0x200		; 	xand	%r13,%r13,0x00008000
	and	%r13,0x0
	sra	%r13,0x8	; 	xsra	%r13,13
	sra	%r13,0x5
	ld.w	%r10,%r4
	sra	%r10,0x8	; 	xsra	%r10,16
	sra	%r10,0x8
	ld.w	%r11,%r10
	and	%r11,0x1	; 	xand	%r11,%r11,0x00000001
	ld.uh	%r10,%r4
	cmp	%r10,0x0
	jrne	__LX76		; 	xjrne	__L76
	ld.w	%r10,%r15
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
	or	%r6,%r10
	ld.w	%r10,%r6
	jp	__LX78		; 	xjp	__L78
__LX76:				; __L76:
	ld.w	%r10,%r6
	or	%r10,%r15
__LX78:				; __L78:
	or	%r10,%r13
	or	%r10,%r11
	ld.b	[%r5],%r10	; 	xld.b	[%r5],%r10
	ld.uh	%r10,%r4
	ret
	.align	1
	.global	z80_SBC16
z80_SBC16:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.w	%r5,%r12
	ld.ub	%r15,[%r5]	; 	xld.ub	%r15,[%r5]
	and	%r15,0x1	; 	xand	%r15,%r15,0x00000001
	ld.uh	%r12,%r13
	ld.uh	%r10,%r14
	ld.w	%r7,%r12
	sub	%r7,%r10
	ld.w	%r10,%r7
	ld.w	%r4,%r10
	sub	%r4,%r15
	ld.w	%r10,%r4
	sra	%r10,0x8	; 	xsra	%r10,8
	ld.w	%r6,%r10
	ext	0x2		; 	xand	%r6,%r6,0x000000a8
	and	%r6,0x28
	ext	0x3f		; 	xld.w	%r11,0x00000fff		; 4095
	ld.w	%r11,0x3f
	ld.w	%r10,%r11
	and	%r10,%r13
	and	%r11,%r14
	sub	%r10,%r11
	sub	%r10,%r15
	sra	%r10,0x8	; 	xsra	%r10,8
	ld.w	%r15,%r10
	and	%r15,0x10	; 	xand	%r15,%r15,0x00000010
	xor	%r13,%r14
	ld.uh	%r13,%r13
	xor	%r12,%r4
	and	%r13,%r12
	ext	0x200		; 	xand	%r13,%r13,0x00008000
	and	%r13,0x0
	sra	%r13,0x8	; 	xsra	%r13,13
	sra	%r13,0x5
	ld.w	%r10,%r4
	sra	%r10,0x8	; 	xsra	%r10,16
	sra	%r10,0x8
	ld.w	%r11,%r10
	and	%r11,0x1	; 	xand	%r11,%r11,0x00000001
	ld.uh	%r10,%r4
	cmp	%r10,0x0
	jrne	__LX80		; 	xjrne	__L80
	ld.w	%r10,%r15
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
	or	%r6,%r10
	ld.w	%r10,%r6
	jp	__LX82		; 	xjp	__L82
__LX80:				; __L80:
	ld.w	%r10,%r6
	or	%r10,%r15
__LX82:				; __L82:
	or	%r10,%r13
	or	%r11,0x2	; 	xoor	%r11,%r11,0x00000002
	or	%r10,%r11
	ld.b	[%r5],%r10	; 	xld.b	[%r5],%r10
	ld.uh	%r10,%r4
	ret
	.align	1
	.global	z80_RL
z80_RL:
;	.frame	%sp,24,$31		# vars= 4, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x1		; 	xsub	%sp,%sp,4
	ld.w	%r2,%r12
	ld.w	%r0,%r13
	sll	%r13,0x1	; 	xsll	%r13,1
	ld.ub	%r10,[%r2]	; 	xld.ub	%r10,[%r2]
	and	%r10,0x1	; 	xand	%r10,%r10,0x00000001
	or	%r13,%r10
	ld.b	[%sp+0x0],%r13	; 	xld.b	[%sp],%r13
	ld.w	%r3,%r13
	ext	0x2		; 	xand	%r3,%r3,0x000000a8
	and	%r3,0x28
	ld.ub	%r1,[%sp+0x0]	; 	xld.ub	%r1,[%sp]
	ld.w	%r12,%r1
	ext	z80_PARITY@rm	; 	xcall	z80_PARITY
	call	z80_PARITY@rl
	ld.ub	%r10,%r10
	ld.ub	%r0,%r0
	srl	%r0,0x7		; 	xsrl	%r0,7
	cmp	%r1,0x0
	jrne	__LX84		; 	xjrne	__L84
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
__LX84:				; __L84:
	or	%r3,%r10
	ld.w	%r10,%r3
	or	%r10,%r0
	ld.b	[%r2],%r10	; 	xld.b	[%r2],%r10
	ld.ub	%r10,[%sp+0x0]	; 	xld.ub	%r10,[%sp]
	add	%sp,0x1		; 	xadd	%sp,%sp,4
	popn	%r3
	ret
	.align	1
	.global	z80_RLC
z80_RLC:
;	.frame	%sp,24,$31		# vars= 4, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x1		; 	xsub	%sp,%sp,4
	ld.w	[%sp+0x0],%r12	; 	xld.w	[%sp],%r12
	ld.ub	%r0,%r13
	srl	%r0,0x7		; 	xsrl	%r0,7
	sll	%r13,0x1	; 	xsll	%r13,1
	ld.w	%r10,%r0
	or	%r10,%r13
	ld.w	%r3,%r10
	ld.w	%r2,%r10
	ext	0x2		; 	xand	%r2,%r2,0x000000a8
	and	%r2,0x28
	ld.ub	%r1,%r3
	ld.w	%r12,%r1
	ext	z80_PARITY@rm	; 	xcall	z80_PARITY
	call	z80_PARITY@rl
	ld.ub	%r10,%r10
	ld.ub	%r0,%r0
	cmp	%r1,0x0
	jrne	__LX87		; 	xjrne	__L87
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
__LX87:				; __L87:
	or	%r2,%r10
	ld.w	%r10,%r2
	or	%r10,%r0
	ld.w	%r11,[%sp+0x0]	; 	xld.w	%r11,[%sp]
	ld.b	[%r11],%r10	; 	xld.b	[%r11],%r10
	ld.ub	%r10,%r3
	add	%sp,0x1		; 	xadd	%sp,%sp,4
	popn	%r3
	ret
	.align	1
	.global	z80_RR
z80_RR:
;	.frame	%sp,24,$31		# vars= 4, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x1		; 	xsub	%sp,%sp,4
	ld.w	%r2,%r12
	ld.w	%r1,%r13
	ld.ub	%r10,%r1
	srl	%r10,0x1	; 	xsrl	%r10,1
	ld.ub	%r11,[%r2]	; 	xld.ub	%r11,[%r2]
	sll	%r11,0x7	; 	xsll	%r11,7
	or	%r10,%r11
	ld.b	[%sp+0x0],%r10	; 	xld.b	[%sp],%r10
	ld.w	%r3,%r10
	ext	0x2		; 	xand	%r3,%r3,0x000000a8
	and	%r3,0x28
	ld.ub	%r0,[%sp+0x0]	; 	xld.ub	%r0,[%sp]
	ld.w	%r12,%r0
	ext	z80_PARITY@rm	; 	xcall	z80_PARITY
	call	z80_PARITY@rl
	ld.ub	%r10,%r10
	and	%r1,0x1		; 	xand	%r1,%r1,0x00000001
	cmp	%r0,0x0
	jrne	__LX90		; 	xjrne	__L90
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
__LX90:				; __L90:
	or	%r3,%r10
	ld.w	%r10,%r3
	or	%r10,%r1
	ld.b	[%r2],%r10	; 	xld.b	[%r2],%r10
	ld.ub	%r10,[%sp+0x0]	; 	xld.ub	%r10,[%sp]
	add	%sp,0x1		; 	xadd	%sp,%sp,4
	popn	%r3
	ret
	.align	1
	.global	z80_RRC
z80_RRC:
;	.frame	%sp,24,$31		# vars= 4, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x1		; 	xsub	%sp,%sp,4
	ld.w	[%sp+0x0],%r12	; 	xld.w	[%sp],%r12
	ld.w	%r0,%r13
	ld.ub	%r10,%r0
	srl	%r10,0x1	; 	xsrl	%r10,1
	ld.w	%r11,%r0
	sll	%r11,0x7	; 	xsll	%r11,7
	or	%r10,%r11
	ld.w	%r3,%r10
	ld.w	%r2,%r10
	ext	0x2		; 	xand	%r2,%r2,0x000000a8
	and	%r2,0x28
	ld.ub	%r1,%r3
	ld.w	%r12,%r1
	ext	z80_PARITY@rm	; 	xcall	z80_PARITY
	call	z80_PARITY@rl
	ld.ub	%r10,%r10
	and	%r0,0x1		; 	xand	%r0,%r0,0x00000001
	cmp	%r1,0x0
	jrne	__LX93		; 	xjrne	__L93
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
__LX93:				; __L93:
	or	%r2,%r10
	ld.w	%r10,%r2
	or	%r10,%r0
	ld.w	%r14,[%sp+0x0]	; 	xld.w	%r14,[%sp]
	ld.b	[%r14],%r10	; 	xld.b	[%r14],%r10
	ld.ub	%r10,%r3
	add	%sp,0x1		; 	xadd	%sp,%sp,4
	popn	%r3
	ret
	.align	1
	.global	z80_SLA
z80_SLA:
;	.frame	%sp,24,$31		# vars= 4, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x1		; 	xsub	%sp,%sp,4
	ld.w	[%sp+0x0],%r12	; 	xld.w	[%sp],%r12
	ld.w	%r0,%r13
	sll	%r13,0x1	; 	xsll	%r13,1
	ld.w	%r3,%r13
	ld.w	%r2,%r13
	ext	0x2		; 	xand	%r2,%r2,0x000000a8
	and	%r2,0x28
	ld.ub	%r1,%r3
	ld.w	%r12,%r1
	ext	z80_PARITY@rm	; 	xcall	z80_PARITY
	call	z80_PARITY@rl
	ld.ub	%r10,%r10
	ld.ub	%r0,%r0
	srl	%r0,0x7		; 	xsrl	%r0,7
	cmp	%r1,0x0
	jrne	__LX96		; 	xjrne	__L96
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
__LX96:				; __L96:
	or	%r2,%r10
	ld.w	%r10,%r2
	or	%r10,%r0
	ld.w	%r11,[%sp+0x0]	; 	xld.w	%r11,[%sp]
	ld.b	[%r11],%r10	; 	xld.b	[%r11],%r10
	ld.ub	%r10,%r3
	add	%sp,0x1		; 	xadd	%sp,%sp,4
	popn	%r3
	ret
	.align	1
	.global	z80_SRA
z80_SRA:
;	.frame	%sp,24,$31		# vars= 4, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x1		; 	xsub	%sp,%sp,4
	ld.w	[%sp+0x0],%r12	; 	xld.w	[%sp],%r12
	ld.w	%r0,%r13
	ld.b	%r10,%r0
	sra	%r10,0x1	; 	xsra	%r10,1
	ld.w	%r3,%r10
	ld.w	%r2,%r10
	ext	0x2		; 	xand	%r2,%r2,0x000000a8
	and	%r2,0x28
	ld.ub	%r1,%r3
	ld.w	%r12,%r1
	ext	z80_PARITY@rm	; 	xcall	z80_PARITY
	call	z80_PARITY@rl
	ld.ub	%r10,%r10
	and	%r0,0x1		; 	xand	%r0,%r0,0x00000001
	cmp	%r1,0x0
	jrne	__LX99		; 	xjrne	__L99
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
__LX99:				; __L99:
	or	%r2,%r10
	ld.w	%r10,%r2
	or	%r10,%r0
	ld.w	%r11,[%sp+0x0]	; 	xld.w	%r11,[%sp]
	ld.b	[%r11],%r10	; 	xld.b	[%r11],%r10
	ld.ub	%r10,%r3
	add	%sp,0x1		; 	xadd	%sp,%sp,4
	popn	%r3
	ret
	.align	1
	.global	z80_SRL
z80_SRL:
;	.frame	%sp,24,$31		# vars= 4, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x1		; 	xsub	%sp,%sp,4
	ld.w	[%sp+0x0],%r12	; 	xld.w	[%sp],%r12
	ld.w	%r0,%r13
	ld.ub	%r10,%r0
	srl	%r10,0x1	; 	xsrl	%r10,1
	ld.w	%r3,%r10
	ld.w	%r2,%r10
	ext	0x0		; 	xand	%r2,%r2,0x00000028
	and	%r2,0x28
	ld.ub	%r1,%r3
	ld.w	%r12,%r1
	ext	z80_PARITY@rm	; 	xcall	z80_PARITY
	call	z80_PARITY@rl
	ld.ub	%r10,%r10
	and	%r0,0x1		; 	xand	%r0,%r0,0x00000001
	cmp	%r1,0x0
	jrne	__LX102		; 	xjrne	__L102
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
__LX102:				; __L102:
	or	%r2,%r10
	ld.w	%r10,%r2
	or	%r10,%r0
	ld.w	%r11,[%sp+0x0]	; 	xld.w	%r11,[%sp]
	ld.b	[%r11],%r10	; 	xld.b	[%r11],%r10
	ld.ub	%r10,%r3
	add	%sp,0x1		; 	xadd	%sp,%sp,4
	popn	%r3
	ret
	.align	1
	.global	z80_BIT
z80_BIT:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.ub	%r13,%r13
	ld.w	%r10,0x1	; 	xld.w	%r10,0x00000001		; 1
	ld.w	%r9,%r13	; 	xsll	%r10,%r13
	and	%r9,0x1f
	cmp	%r9,0x8
	jrle	4
	sll	%r10,0x8
	jp.d	-3
	sub	%r9,0x8
	sll	%r10,%r9
	and	%r14,%r10
	ld.w	%r11,%r14
	ext	0x2		; 	xand	%r11,%r11,0x00000080
	and	%r11,0x0
	ld.ub	%r10,[%r12]	; 	xld.ub	%r10,[%r12]
	and	%r10,0x1	; 	xand	%r10,%r10,0x00000001
	ld.ub	%r14,%r14
	cmp	%r14,0x0
	jreq	__LX105		; 	xjreq	__L105
	or	%r10,0x10	; 	xoor	%r10,%r10,0x00000010
	jp	__LX107		; 	xjp	__L107
__LX105:				; __L105:
	ext	0x1		; 	xoor	%r10,%r10,0x00000054
	or	%r10,0x14
__LX107:				; __L107:
	or	%r11,%r10
	ld.w	%r10,%r11
	ld.b	[%r12],%r10	; 	xld.b	[%r12],%r10
	ret
